%define aep_version 2.1
%define bcm_version 1.81
%define cards aep1000 bcm5820

Summary: Hardware cryptographic accelerator support.
Name: hwcrypto
Version: 1.0
Release: 14
License: GPL
Group: System Environment/Base
Source0: bcm5820-%{bcm_version}.tgz
Source1: aep_host_sw.tar.gz
Source2: bcm5820.init
Source3: aep1000.init
Source4: hwcrypto.txt
Source5: aeptarg.bin
Patch0: bcm5820-1.81-log.patch
Patch1: aep1000-redhat.patch
Patch2: bcm5820-1.81-link.patch
Patch3: bcm5820-1.81-noclear.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root 
Obsoletes: bcm5820
Prereq: /sbin/chkconfig, /sbin/service
Requires: gawk
ExclusiveArch: %{ix86}

%description
This package contains the shared libraries used to interface with
hardware cryptographic accelerators under Linux.

%prep
%setup -q -c -a 1

# Prep the AEP tree.
pushd Host
%patch1 -p1 -b .redhat
popd

# Prep the Broadcom tree.
pushd bcm5820-%{bcm_version}
%patch0 -p1 -b .log
%patch2 -p1 -b .link
%patch3 -p0 -b .noclear
cp snmp/readme.txt snmp/readme.snmp
popd

find -name "*.c" -o -name "*.h" | xargs chmod -x

%build
# Build AEP.
pushd Host
ln -s libaep.so.1 API/libaep.so
make -C API
make -C Daemon
make -C Test/quicktest
make -C versionApp
make -C aeploader
popd

# Build Broadcom.
pushd bcm5820-%{bcm_version}
Make() {
INCLUDES="-I../SRL -I../Linux -I../ubslib"
make \
	CFLAGS="$RPM_OPT_FLAGS -DUSER_APPLICATION -fPIC $INCLUDES" \
	SHRCFLAGS="$RPM_OPT_FLAGS -DUSER_APPLICATION -fPIC $INCLUDES" \
	THIS_OSTYPE=`uname` $@
}
make clean
Make -C cndiag 
Make -C ubslib
Make -C stats
popd

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}

pushd bcm5820-%{bcm_version}
install -m755 cndiag/b58diag $RPM_BUILD_ROOT%{_bindir}/
install -m755 stats/b58stats $RPM_BUILD_ROOT%{_bindir}/

install -m755 ubslib/lib*.so* $RPM_BUILD_ROOT%{_libdir}/
install -m644 ubslib/lib*.a $RPM_BUILD_ROOT%{_libdir}/
# This symlink is required for OpenSSL to be able to find the library.
(cd $RPM_BUILD_ROOT%{_libdir}; ln -s libubsec.so.* libubsec.so)

mkdir -p $RPM_BUILD_ROOT%{_datadir}/snmp/mibs
install -m644 snmp/*.mib $RPM_BUILD_ROOT%{_datadir}/snmp/mibs/

install -m755 snmp/get5820stats $RPM_BUILD_ROOT%{_bindir}
install -m755 snmp/gen5820traps $RPM_BUILD_ROOT%{_bindir}
popd

pushd Host
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/aep
install -m755 API/libaep.so.* $RPM_BUILD_ROOT%{_libdir}/
# This symlink is required for OpenSSL to be able to find the library.
(cd $RPM_BUILD_ROOT%{_libdir}; ln -s libaep.so.* libaep.so)
install -m755 aeploader/aepload $RPM_BUILD_ROOT%{_sbindir}/
install -m755 Test/quicktest/aeptest $RPM_BUILD_ROOT%{_sbindir}/
install -m755 versionApp/aepversion $RPM_BUILD_ROOT%{_sbindir}/
install -m755 Daemon/aepdaemon $RPM_BUILD_ROOT%{_sbindir}/
install -m644 Daemon/aep*.conf    $RPM_BUILD_ROOT%{_sysconfdir}/
install -m600 $RPM_SOURCE_DIR/aeptarg.bin $RPM_BUILD_ROOT%{_sysconfdir}/aep/
popd

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
for card in %{cards} ; do
install -m755 $RPM_SOURCE_DIR/${card}.init $RPM_BUILD_ROOT/etc/rc.d/init.d/$card
done

/sbin/ldconfig -n $RPM_BUILD_ROOT/%{_libdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post 
/sbin/ldconfig
for card in %{cards} ; do
	/sbin/chkconfig --add $card
done

%postun -p /sbin/ldconfig

%preun
if [ $1 = 0 ] ; then
	for card in %{cards} ; do
		/sbin/service $card stop >/dev/null 2>&1
		/sbin/chkconfig --del $card
	done
fi

%files
%defattr(-,root,root)
%doc bcm5820-%{bcm_version}/snmp/readme.snmp $RPM_SOURCE_DIR/hwcrypto.txt
%config /etc/*.conf
%config /etc/aep
%config /etc/rc.d/init.d/*
%{_bindir}/*
%{_libdir}/lib*
%{_sbindir}/*
%{_datadir}/snmp/mibs/*

%changelog
* Tue Feb 04 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- add symlinks to shared libs

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Wed Dec 18 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-12
- include just libraries under %%{_libdir}
- give libubsec a soname

* Wed Dec 18 2002 Tim Powers <timp@redhat.com> 1.0-11
- rebuild

* Wed Dec  18 2002 Dan Walsh <dwalsh@redhat.com> 1.0-10
- improve service description

* Mon Nov  4 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-9
- fix suppressing of screen clearing

* Wed Oct 30 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-8
- make the bcm5820 status option print stats if the module is loaded

* Fri Aug 23 2002 Jakub Jelinek <jakub@redhat.com> 1.0-7
- link libubsec.so with gcc, not ld

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Fri May 17 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-4
- rebuild in new environment

* Tue Apr 16 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-3
- add the aeptarg.bin file provided by AEP

* Thu Apr 11 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-2
- update doc text file, aep2000 support isn't in here

* Tue Apr  9 2002 Nalin Dahyabhai <nalin@redhat.com> 1.0-1
- merge in AEP userland stuffs
- rename to hwcrypto, obsolete bcm5820
- write up short text doc

* Wed Mar 27 2002 Nalin Dahyabhai <nalin@redhat.com> 1.81-3
- change init script priority from 11/89 to 30/70, so that it'll be started
  after network filesystems are mounted (#61774)

* Tue Mar 26 2002 Nalin Dahyabhai <nalin@redhat.com> 1.81-2
- include b58stats

* Mon Mar 25 2002 Nalin Dahyabhai <nalin@redhat.com> 1.81-1
- merge changes from 1.17-7

* Wed Mar 20 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.17-7
- Tell it what OS this is...

* Tue Mar 12 2002 Nalin Dahyabhai <nalin@redhat.com> 1.81-0
- refresh of the driver and userland from Broadcom

* Tue Aug 28 2001 Nalin Dahyabhai <nalin@redhat.com> 1.17-6
- take some debug code out of get5820stats

* Fri Aug 23 2001 Nalin Dahyabhai <nalin@redhat.com> 1.17-5
- disable in openssl.cnf if module load fails

* Wed Aug 22 2001 Nalin Dahyabhai <nalin@redhat.com> 1.17-4
- mark that the service no longer needs to be stopped when it's stopped

* Tue Aug 14 2001 Nalin Dahyabhai <nalin@redhat.com>
- munge openssl.cnf in the init script, taking care to modify the right section

* Thu Aug  9 2001 Arjan van de Ven <arjanv@redhat.com>
- update to 1.17
- actually remove the postun

* Wed Aug  1 2001 Nalin Dahyabhai <nalin@redhat.com>
- refresh to 1.13
- remove postun, which isn't necessary (no daemon to shut down or restart)

* Tue Jul 24 2001 Bill Nottingham <notting@redhat.com>
- fix license, vendor

* Fri Jul 20 2001 Nalin Dahyabhai <nalin@redhat.com>
- disable the init script by default

* Wed Jul 18 2001 Nalin Dahyabhai <nalin@redhat.com>
- take the execute bit off of the static library

* Tue Jul 17 2001 Nalin Dahyabhai <nalin@redhat.com>
- initial package, based on Peter Wang's .spec file
- don't build kernel modules -- they're in the kernel packages
